__doc__='''EmployX product module
$Id: EmployX.py,v 2.0 2002/02/08 16:50:30 johanc Exp $'''
__version__='$Revision: 2.0 $'[11:-2]


import Globals
from Globals import DTMLFile
from string import join, split

from Acquisition import Implicit
from AccessControl.Role import RoleManager
from OFS.SimpleItem import SimpleItem
from OFS.PropertyManager import PropertyManager

from Products.ZPatterns.DataSkins import DataSkin



manage_employx_add_form = DTMLFile('dtml/DSmanage_employx_add_form', globals())

def manage_employx_add(self, id, REQUEST=None):
    """Add a EmployX to a folder."""

    ob = EmployX(id)
    self._setObject(id,ob)
    ob = ob.__of__(self)
    if REQUEST is not None:
        get = REQUEST.get
        ob.__post_init__(first=get('first',''), last=get('last',''), email=get('email',''), salary=get('salary',0))
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


class EmployX(DataSkin, SimpleItem, Implicit, RoleManager, PropertyManager):
    """EmployX object.
    """

    meta_type = 'EmployX'

    # Necessary?
    _isRackMountable = 1

    _properties=()

    manage_options = (
            {'label': 'Edit',       'action': 'manage_edit' },
            {'label': 'Debug',      'action':'debug'},
            {'label': 'View',       'action': 'index_html'},
            {'label': 'Security',   'action': 'manage_access'},
        )


    __ac_permissions__=(
                ('View management screens', ('debug','manage_edit','index_html')),
                ('Change permissions',      ('manage_access',)           ),
                ('Change EmployX'     ,     ('manage_edit',)             ),
                )

    first='f'
    last='l'
    email='e'
    salary=0

    def __init__(self,id):
        """initialise a new instance of EmployX"""
        DataSkin.__init__(self,id)

    def __post_init__(self, first='', last='', email='', salary=0):
        self.first=first
        self.last=last
        self.email=email
        self.salary=salary

    def repr(self, obj):
        return repr(obj)

    def debug(self):
        """ Print object's __dict__ """
        result = ""
        for k, v in self.__dict__.items():
            result = "%s\n%s : %s" % (result, repr(k), repr(v))
        return """<body><pre>%s</pre></body>""" % (result)


    _manage_edit = DTMLFile('dtml/DSmanage_edit_employx', globals())
    def manage_edit(self,REQUEST=None):
        """Save changes to the EmplyX Object and show the edit manage interface."""
        if REQUEST.has_key('first'):
            self.first = REQUEST['first']
        if REQUEST.has_key('last'):
            self.last = REQUEST['last']
        if REQUEST.has_key('email'):
            self.email = REQUEST['email']
        if REQUEST.has_key('salary'):
            self.salary = REQUEST['salary']
        if REQUEST.has_key('action_save'):
            self.zopeurl = self.getPhysicalURL()
        if REQUEST is not None:
            return self._manage_edit(self,REQUEST=REQUEST,management_view='Edit')

    def getPhysicalURL(self):
        p_path = self.getPhysicalPath()
        p_url = join(p_path,'/')
        if p_url=='': p_url='/'
        return p_url


    index_html  = DTMLFile('dtml/DSindex_html_employx', globals())

Globals.InitializeClass(EmployX)


def initialize(context):
    """Initialize the EmployX product.
    """


    context.registerClass(
            EmployX,
            constructors = (
                manage_employx_add_form,
                manage_employx_add),
            icon = 'www/item.gif'
        )
    # We need this so that this class will show up in the list of classes
    # Customizers can customize. (Thanks Steve)
    context.registerBaseClass(EmployX)


